// ̧قDoxygenpɏĂ܂B
/*! \file ********************************************************************
*
* Atmel Corporation
*
* - ̧		: bootloader_smbus.c
* - ߲		: IAR EWAVR 4.11A
*
* - xҰ		: avr@atmel.com
*
* - x޲	: ATmega406̂
*
* - pLq	: AVR453 - drQƊ݌v
*
* - 		: ATmega406pSMBusxް۰
*
* - 		: rgf-apt
* - 		: $Revision: 1.27 $
* - t		: $Date: 2005N99() 10:27:38 UTC $
* - XV		: $Author: rksnilsberg $
*
*****************************************************************************/

/*! \page doc_page1 ُ߲
* \section ް۰
* ̿ĳIAR Embedded Workbench, 4.11A/4.10BpɏĂ܂A3.20C
* gč\z邱Ƃł܂B\n
* ۼުĂ쐬ɂ:
* ۼުĂɂbootloader_smbus.çقǉA޲-v3AgpARAMZڼ޽
* ȂAI/Oݸٰ ̧قޯĒ`AœK͒ɐݒA
* (ƋɊ܂܂)$PROJ_DIR$\\m406s_2kwBootLdr.xclݶ̧قŏ㏑A
* o͌`ޯޗpubrof8AJpintel_extendedłB\n
* ް۰ޕt޲ɂ́Aŏ޲ް۰ނǍ
* 旧޲ȂŎ啔Ȃ΂Ȃ܂B
*/

//#define ENABLE_TESTCODE

#include "pgmspace.h"
#include <inavr.h>

#define MODULE_BOOTLDR		/* bootldr.hŕϐݽݽ邱Ƃۏ */
#include "bootldr.h"
#include "iom406_320.h"
//#include "iom406.h"		// ATmega406 (EW 410)pIAŖͯ
#include "flash.h"

void TWI_handler(void);
void SMB_RestoreBus(void);
unsigned char FastCRC(unsigned char LastCRC, unsigned char newbyte);
void SMB_BusTimeout(void);
void SMB_Reply(void);
void SMB_CmdInterpreter(void);
void LoopMemory(void);


//=======================================================================

// ͔͈͊OSMBNusߌɎg܂B
#define HIGHEST_SMB_CMD		0x3F

// 2̪TWSR()l
// Oul0̂߁A޲Ă̎ՕsvȂƂɒӂĂB

// LKpłTWIԕ:
#define TWS_MASK		0xF8	/* 2ԎՕ */
#define TWS_NSTAT		0xF8	/* ݗp\ȏԂȂ */

// 呕uϐԕ:
#define TWS_START		0x08
#define TWS_RESTART		0x10
#define TWS_WRITE_ACK	0x18	/* SLA+WoAACK擾 */
#define TWS_WRITE_NAK	0x20	/* SLA+WoANAK擾 */
#define TWS_TXDATA_ACK	0x28	/* ްMAACKM */
#define TWS_TXDATA_NAK	0x30	/* ްMANAKM */
#define TWS_LOST_ARB	0x38	/* ޽s */

#define TWS_READ_ACK	0x40	/* SLA+RvACK擾 */
#define TWS_READ_NAK	0x48	/* SLA+RvNAK擾 */
#define TWS_RXDATA_ACK	0x50	/* ްMAACKԂ */
#define TWS_RXDATA_NACK	0x58	/* ްMANAKԂ */

// ]u֘Aԕ
#define TWS_SLA_W		0x60	/* SLA+W擾 */
#define TWS_SLA_R		0xA8	/* SLA+R擾 */
#define TWS_RDATA		0x80	/* ް ޲Ď擾 */
#define TWS_RCMD		0x80	/* ޲Ď擾 */
#define TWS_RSTOP		0xA0	/* ~擾 */
#define TWS_REPEAT		0xA0	/* đJn擾 */
#define TWS_RACK		0xB8	/* ް ޲đoAACKԂ擾 */
#define TWS_RNAK		0xC0	/* ް ޲đoANAKԂ擾 */
#define TWS_FINAL		0xC8	/* ŏI޲đoAACKԂ擾 */
#define TWS_BERR		0x00	/* ޽ُ푘 */

// 2l

#define TWC_GO			0x85	/* TWINT; Ɗ荞݋L */
#define TWC_READ_NoACK	0x85	/* ޲ēǂݍ݁AIACKłȂ */
#define TWC_START		0xA5	/* JnoAƊ荞݋L */
#define TWC_STOP		0x94	/* IɊ荞݂*֎~*̂܂ */
#define TWC_RESTART		0xB5	/* ~oĂъJno; 荞݋ */


//=======================================================================

unsigned char TW_TxBuf[36];		// ǂ̑oɑ΂Ă[ȒłȂ΂Ȃ܂B
unsigned char TW_TxBufCnt;		// ɏՕɂǂ̈ʗL޲Ă邩
unsigned char TW_TxBufIndex;

unsigned char TW_RxBuf[36];		// MްɒlAď[傫Ȃ΂Ȃ܂B
unsigned char TW_RxBufCnt;		// SLA+(Cmd)+(Count)+32޲+PEC=36
unsigned char TW_RxBufIndex;

unsigned char TW_state;			// ԕϐ
unsigned char UsePEC;			// PECgp͊ŋ֎~

unsigned char LoopFlag;			// ᑬؑŌJԂ?
unsigned char BigData;			// ׸ށA߹'I'߂s?
unsigned char src_i;
unsigned char dest_i;
unsigned char ctr;
unsigned char lomemptr;
unsigned char himemptr;
unsigned char __flash *fptr;
unsigned int eptr;

unsigned char SRAMbuffer[128];	// ׯ ؂߰ނ̑傫(64 **)łB

// ޲Ă͕\ނɉ邩邽߂TWI׸ނ܂݂܂B
// ޲Ăɔ0łꍇA\ނ͂̓eœ܂B
// ꂪƕ\ނ̗ŏƂ͌A\ނ֘A閽߂̏I
// ׸ ޲ĂĂ܂܂SMBus~邽߁AVOLATILE錾͕sv
// B
unsigned char TWI_CmdFlags;
  #define SMB_GenBusTimeout		1	/* ُ푘̂߁A޽Ԑ\ނɍ܂B! */
  #define SMB_SetUpReply		2	/* \ނTW_TxBuf[]ݒ܂B */
  #define SMB_GotCmdData		4	/* MߑŜ\ނɉ߂܂B */


unsigned char Status;				// ͑SϐŁAcmd -x2Fgǂݍ݂ɑ΂B̉łB
  #define SUCCESS				0
  #define BUSY					1
  #define BADPARAM				2
  #define CRCERROR				3
  #define FAILURE				0xFF


//=======================================================================

// ؾĊǗ̗:
//
// pނSMBusߕsOptionalMfgCmd5߂MꂽɂȒP
// ް۰ނɓ邽߁AؾČ׸ނĎ܂BLɂꂽǂ׸ނȂɂ
// ɓꍇAp炱ɔ΂ꂽƐ邱ƂłA]āAް۰
//  ނƂӐ}Ɛ邱Ƃł܂BȂ΁Aڍs
// ǂꂩؾ ׸ނLɂĂꍇA0x0000ɑ݂L޸邩
// ׁAȂΗLȲҰނ擾邽߂ް۰ނ𑖂点AȂ΁A
// p۸тɔł𑖂点܂B
//
//! \todo O: ޯ ׸ނLɂĂꍇApނ̲Ұނɖ肪
//!				\܂Bꂪ̏ꍇŉP邩߂
//!				͎gp҂ɔC܂B

void __low_level_init(void)
{
	unsigned char __flash * ptr = 0;

	if(!(MCUSR))		// LؾČꍇApނӐ}Iɂɗ܂B
		return;			// ް۰ނ𓮂ƂKvƐ܂B

	// ؾČLɂꂽBꂪޯނꍇAނ̖肪
	// 邩ꂸAؾČƈႤlɏ邱ƂKv܂B
	// Ȃ΁Aɂ̺ނǉĂB
	if(MCUSR & (1<<WDRF))
	{
		//! \todo ޯ ؾĂ邽߂ɺނǉĂB
	}

	// ؾČLɂAؾ ޸$FFFFȂAް۰ނ𑖂点邱
	// ƂKvƐAȂ΁A$0000̉p ؾ ޸ɔсAp
	// ނOKƐ܂B
	if((*ptr++ != 0xFF) || (*ptr != 0xFF))
	{
		MCUCR &= (1<<IVSEL);
		asm("jmp 0");
	}
	// ̎_ŁAp̲̈ҰނLłȂ邽߁Aǂް۰ނ𑖂点邱ƂKvłB
}

void init_boot(void)
{
	__disable_interrupt();
	TW_TxBufCnt = 0;		// ɏՕɂǂʗL޲Ă邩
	TW_TxBufIndex = 0;
	TW_RxBufCnt = 0;
	TW_RxBufIndex = 0;
	TW_state = 0;
	UsePEC = 0;
	Status = SUCCESS;
	LoopFlag = 0;
	BigData = 0;

	SMB_RestoreBus();
	TWBCSR = (1<<TWBCIF) | (1<<TWBDT1) | (1<<TWBDT0) | (0<<TWBCIP);
}


/* ************************************************************* */
/* ************************************************************* */
/* ************************************************************* */

// ȉ̊֐SMBusɊÂISP߂ɑ΂ēްǂׂ̎
// ݂܂B

#ifdef ENABLE_TESTCODE

void BOOT_TEST_EF(void)
{
	// ׯ ߰ޏ@\(ŏɐo0x0000`0x007Fɔzu)
	TWI_CmdFlags = SMB_GotCmdData;
	TW_RxBuf[TWRX_CMD] = 'E';		// 
	TW_RxBuf[TWRX_MEM] = 'F';		// ׯ 
	TW_RxBuf[TWRX_LOADDR] = 0x80;
	TW_RxBuf[TWRX_HIADDR] = 0;
	UsePEC = 0;
}

void BOOT_TEST_EE(void)
{
	// EEPROM@\(ŏɐo0x1F0`0x1FFɔzu; 0x1F9܂łׂ)
	TWI_CmdFlags = SMB_GotCmdData;
	TW_RxBuf[TWRX_CMD] = 'E';		// 
	TW_RxBuf[TWRX_MEM] = 'E';		// EEPROM
	TW_RxBuf[TWRX_LOADDR] = 0xF0;
	TW_RxBuf[TWRX_HIADDR] = 0x01;
	TW_RxBuf[TWRX_SIZE] = 0x0a;		// 10޲Ăs(2ׂ̂̏ꍇ̌)
	UsePEC = 0;
}

void BOOT_TEST_I(void)
{
	unsigned char i;
	TWI_CmdFlags = SMB_GotCmdData;
	TW_RxBuf[TWRX_CMD] = 'I';		// }
	TW_RxBuf[TWRX_LOADDR] = 0;
	TW_RxBuf[TWRX_HIADDR] = 0;
	for(i=0; i<16; i++)
		TW_RxBuf[TWRX_DATA+i]=i+33;	// Cް
	TW_RxBuf[TWRX_OFFSET] = 0x33;	// Cӂ̕ψ0x33Ŏn܂SRAMɏՕް}
	TW_RxBuf[TWRX_SIZE] = 16;
	UsePEC = 0;
}

void BOOT_TEST_WF(void)
{
	unsigned char i;
	// ׯ ߰ޏ݋@\(SRAMbufferׯ ؂0x0000`0x007FɊi[)
	// ݌OɊɏՕ𖞂܂B
	for(i=0; i<128; i++)
		SRAMbuffer[i]=i+33;
	TWI_CmdFlags = SMB_GotCmdData;
	TW_RxBuf[TWRX_CMD] = 'W';		// 
	TW_RxBuf[TWRX_MEM] = 'F';		// ׯ 
	TW_RxBuf[TWRX_LOADDR] = 0x80;
	TW_RxBuf[TWRX_HIADDR] = 0;
	UsePEC = 0;
}

void BOOT_TEST_WE(void)
{	// EEPROM݋@\(SRAMbuffeȑȒfЂEEPROM0x1F0`0x1FBɊi[)
	unsigned char i;
	// ݌sOɊɏՕ𖞂܂B
	for(i=0; i<128; i++)
		SRAMbuffer[i]=i+33;
	TWI_CmdFlags = SMB_GotCmdData;
	TW_RxBuf[TWRX_CMD] = 'W';		// 
	TW_RxBuf[TWRX_MEM] = 'E';		// EEPROM
	TW_RxBuf[TWRX_LOADDR] = 0xF0;	// ǂ̱ڽŗǂB
	TW_RxBuf[TWRX_HIADDR] = 0x01;
	TW_RxBuf[TWRX_OFFSET] = 0x33;	// ɏՕ̈Cӂ̉gp
	TW_RxBuf[TWRX_SIZE] = 0x0c;
	UsePEC = 0;
}

void BOOT_TEST_PF(void)
{
	unsigned char i;
	// CߌoRׯ ؓeǂݖ߂Ƃł邱ƂmF
	// ŏSRAMbuffer
	for(i=0; i<128; i++)
		SRAMbuffer[i] = 0;
	// ɕC߂
	TWI_CmdFlags = SMB_GotCmdData;
	TW_RxBuf[TWRX_CMD] = 'P';		// C
	TW_RxBuf[TWRX_MEM] = 'F';		// ׯ 
	TW_RxBuf[TWRX_LOADDR] = 0x80;	// ǂ̱ڽŗǂB
	TW_RxBuf[TWRX_HIADDR] = 0x00;
	UsePEC = 0;
}

void BOOT_TEST_PE(void)
{
	unsigned char i;
	// CߌoREEPROMeǂݖ߂Ƃł邱ƂmF
	// ŏSRAMbuffer
	for(i=0; i<128; i++)
		SRAMbuffer[i] = 0;
	// ɕC߂
	TWI_CmdFlags = SMB_GotCmdData;
	TW_RxBuf[TWRX_CMD] = 'P';		// C
	TW_RxBuf[TWRX_MEM] = 'E';		// EEPROM
	TW_RxBuf[TWRX_LOADDR] = 0xE0;	// ڽ+傫0x200łȂ΂Ȃ܂B
	TW_RxBuf[TWRX_HIADDR] = 0x01;
	TW_RxBuf[TWRX_OFFSET] = 0x00;	// SRAMbuffer̐擪(C)ɂǂݍ
	TW_RxBuf[TWRX_SIZE] = 0x20;		// 128޲Ă܂ł̖]ނǂ̑傫͂ݎ܂B
	UsePEC = 0;
}

unsigned char bigI;

void BOOT_TEST_bigI(void)
{
	unsigned char i;
	TW_RxBuf[TWRX_BLKCNT] = 32;
	TWI_CmdFlags = SMB_GotCmdData;
	TW_RxBuf[TWRX_CMD] = 'I';		// }
	for(i=0; i<26; i++)
		TW_RxBuf[TWRX_DATA+i]=i+1;	// Cӂް
	bigI = i+1;						// ̂߂ɕۑ
	TW_RxBuf[TWRX_OFFSET] = 0;		// Cӂ̕ψ(̾)0x33Ŏn܂SRAMɏՕް}
	TW_RxBuf[TWRX_SIZE] = 128;
	UsePEC = 0;
}

void BOOT_TEST_bigI32(void)
{
	unsigned char i;
	TW_RxBuf[TWRX_BLKCNT] = 32;
	TWI_CmdFlags = SMB_GotCmdData;
	for(i=0; i<32; i++)
		TW_RxBuf[3+i]=i+bigI;		// Cӂް
	bigI += i;						// ̂߂ɕۑ
}

void BOOT_TEST_bigI8(void)
{
	unsigned char i;
	TW_RxBuf[TWRX_BLKCNT] = 6;
	TWI_CmdFlags = SMB_GotCmdData;
	for(i=0; i<6; i++)
		TW_RxBuf[3+i]=i+bigI;
}

void TestManager(void)
{
	static unsigned char testctr = 0;

	switch(testctr)
	{
		case 0:
			BOOT_TEST_I();
			testctr++;
			break;

		case 1:
			BOOT_TEST_WF();
			testctr++;
			break;

		case 2:
			BOOT_TEST_PF();
			testctr++;
			break;

		case 3:
			BOOT_TEST_EF();
			testctr++;
			break;

		case 4:
			if(!LoopFlag)
			{
				BOOT_TEST_WE();
				testctr++;
			}
			break;

		case 5:
			if(!LoopFlag)
			{
				BOOT_TEST_EE();
				testctr++;
			}
			break;

		case 6:
			if(!LoopFlag)
			{
				BOOT_TEST_PE();
				testctr++;
			}
			break;

		case 7:		// Aꂽߌ
			BOOT_TEST_bigI();
			testctr++;
			break;

		case 8:
			BOOT_TEST_bigI32();
			testctr++;
			break;

		case 9:
			BOOT_TEST_bigI32();
			testctr++;
			break;

		case 10:
			BOOT_TEST_bigI32();
			testctr++;
			break;

		case 11:
			BOOT_TEST_bigI8();
			testctr++;
			break;

		case 12:
			break;

	}
}

#endif


/* ************************************************************* */
/* ************************************************************* */
/* ************************************************************* */

void main(void)
{
	init_boot();

	for(;;)
	{

#ifdef ENABLE_TESTCODE
		TestManager();
#endif

		if(TWCR & (1<<TWINT))						// ް۰ނTWI߰ݸނ邱ƂɒӂĂB
			TWI_handler();

		if(TWI_CmdFlags)
		{
			if(TWI_CmdFlags == SMB_SetUpReply)		/* \ނTW_TxBuf[]̏܂B */
			{
				TWI_CmdFlags = 0;
				SMB_Reply();
			}
			else
				if(TWI_CmdFlags == SMB_GotCmdData)
				{
					TWI_CmdFlags = 0;
					SMB_CmdInterpreter();
				}
		else
			if(TWI_CmdFlags == SMB_GenBusTimeout)	/* ُ߁A\ނ޽Ԑ܂B! */
			{
				TWI_CmdFlags = 0;
				SMB_BusTimeout();
			}
		}

		if(LoopFlag)								/* JԂᑬؑײ݂ */
		LoopMemory();
	}
}


/* *************************************************************************
 *
 *   SMBusʐMԋ@\
 *
 ************************************************************************* */

//unsigned char TW_state = TW_IDLE;		// ԕϐ

// ԋ@\̏
enum /*TW_State*/ {TW_IDLE=0, TW_Wait4Cmd, TW_Wait4RW, TW_Wait4Data, TW_ReplyData, TW_MSLA_W, TW_MCMD_W, TW_MDATA_W };

void TWI_handler(void)
{
	unsigned char Status;

	Status = TWSR & 0xF8;				// ͉荞݂n܂B

	switch(TW_state)
	{
		default:
		case TW_IDLE:							// SLA_W܂RSTOPłȂΈُ!
			if(TWS_SLA_W == Status)				// ޯĂƋɏ]uڽv?
			{
				TW_state = TW_Wait4Cmd;
			}
			else
				if(TWS_RSTOP == Status)			// ~AAO̖߂̎c
				{
					;							// ȂB܂B
				}
				else							// 炩ُ̈킠!
				{
					TWI_CmdFlags = SMB_GenBusTimeout;	// ُ׸ށȀԂɗ܂܂B
					TWCR = (1<<TWEA) | (1<<TWEN);		// 荞݋֎~ATWINT׸ނ܂!B
					return;
				}
			TWCR = (1<<TWINT) | (1<<TWEA) | (1<<TWEN);	// ACKċȂ΂Ȃ܂B
			break;

    // ]ȕԂ̗

		case TW_Wait4Cmd:						// ڍsŁA޲ĎM
			if(TWS_RCMD == Status)				// ▽޲ĂM炵
			{
				if(SMBV_Opt5 == TWDR)
				{
					TW_state = TW_Wait4RW;		// Ԑݒ
					TWCR = (1<<TWINT) | (1<<TWEA) | (1<<TWEN);	// ACK
					return;
				}
			}
			// ()'return'̂SĂ̏ꍇňُłB
			TWI_CmdFlags = SMB_GenBusTimeout;	// ޽Ԃ𐶐
			TWCR = (1<<TWEA) | (1<<TWEN);		// 荞݋֎~ATWINT׸ނ܂!B
			TW_state = TW_IDLE;					// ԋ@\ؾ
			break;

		case TW_Wait4RW:						// AƎM邩A܂͑ɉMKv𒲂ׂ܂B
			if(TWS_RDATA == Status)				// ݌^߁Bް󂯓邽߂ɎMɏՕ
			{	// : OptionalMfgFunction5͗ł̉򖽗߂łB
				// ̑S޲ĂɏՕɒuÂɕKvȂ΂PECsƂł܂B
				TW_RxBuf[0] = TWAR & 0xFE;		// PEC͊܂܂]uڽKvƂ܂B
				TW_RxBuf[1] = SMBV_Opt5;		// Ȏo߂i[
				TW_RxBuf[2] = TWDR;				// ޲Ă͉޲ĐłB
				TW_RxBufCnt = TWDR;
				TW_RxBufIndex = 3;				// ɏՕްi[邽߂ɎwW
				TW_state = TW_Wait4Data;
				TWCR = (1<<TWINT) | (1<<TWEA) | (1<<TWEN);	// ACK
			}
			else
				if(TWS_REPEAT == Status)			// đJnÂɓǂݍݖ߂̏Ȃ΂Ȃ܂B
				{	// AȎo߂̉߂ްȂ΂Ȃ܂B
					TWI_CmdFlags = SMB_SetUpReply;	// \ٰ݂TWCR
					TW_state = TW_ReplyData;		// Ԃړ
					TWCR = (1<<TWEA) | (1<<TWEN);	// 荞݋֎~ATWINT׸ނ܂!B
					return;					
				}
				else								// 炩ُ̈!
				{
					TWI_CmdFlags = SMB_GenBusTimeout;	// ޽Ԑ
					TWCR = (1<<TWEA) | (1<<TWEN);	// 荞݋֎~ATWINT׸ނ܂!B
					TW_state = TW_IDLE;				// ԋ@\ؾ
				}
			break;

		case TW_Wait4Data:						// ]uM`
			if(TWS_RDATA == Status)					// ް ޲ĎM
			{
				TW_RxBuf[TW_RxBufIndex++] = TWDR;	// ޲Ăi[
				if(0 == --TW_RxBufCnt)				// Ӑ}SްM?
				{
					TW_RxBufCnt = TW_RxBufIndex;	// ݎwWlL޲ĐƂčėp
					TW_RxBufIndex = 0;				// ̉ߗpł̎wW
					TWI_CmdFlags = SMB_GotCmdData;	// ₱̏\ނɍ܂B
					// \ނُ͍}邩AԂقؾĂ邩A܂͏ɒ~ł̏I
					// TWINT邩̂ǂꂩsӔC܂B(cmd)OKȂA\ނ͒~
					// 悤ɏITW_RxBufCntȂ΂Ȃ܂B\ނPEC܂܂ĂėL𔻒f
					// ߂UsePEC׸ނQƂȂ΂Ȃ܂B
					TWCR = (1<<TWEA) | (1<<TWEN);	// 荞݋֎~ATWINT׸ނ܂!B
					TW_state = TW_IDLE;				// ɒ~Ӑ}APTW_Idleł'H܂'B
					return;
				}
			}
			else
				if(TWS_RSTOP == Status)			// ~AްM͑SďI
				{	// : ߂~̏ꍇA呕uւُ̈ʒmx邽߁APɖ߂𖳎܂B
					TW_state = TW_IDLE;			// SĂ̏ꍇŏԋ@\ؾ
				}
				else									// 炩ُ̈!
				{
					TWI_CmdFlags = SMB_GenBusTimeout;	// ޽Ԑ
					TWCR = (1<<TWEA) | (1<<TWEN);		// 荞݋֎~ATWINT׸ނ܂!B
					TW_state = TW_IDLE;					// ԋ@\ؾ
					return;
				}
			TWCR = (1<<TWINT) | (1<<TWEA) | (1<<TWEN);	// ACK
			break;

		case TW_ReplyData:						// A]uM`
			// : TW_TxBufCnt**PEC޲Ă܂݂܂!B呕uۂPEC޲
			//	   ]ނۂmȂ߁AUsePEC׸ނ̏ԂɊւ炸A
			//	   𑗂Ă݂܂B呕u]܂ȂꍇAPEC޲Ăɏ
			//	   ̊ԂNAK𓾂ł傤BPEC޲Ă܂ޑSĂ𑗂邯ǂ
			//	   ACK𓾂HȏꍇAPECoTWEAޯĂݒ肵Ȃ߁ATWI
			//	   Pʕ͂ǂ ײ݂ŁA]āAُ킪NƂ}邱
			//	   Ƃ͂ł܂B
			if((TWS_SLA_R == Status) || (TWS_RACK == Status))	// ްo
			{
				TWDR = TW_TxBuf[TW_TxBufIndex++];	// ްo
				if(--TW_TxBufCnt == 0)				// ɏՕAAPEC?
					TWCR = (1<<TWINT) | (1<<TWEN);	// ͂ÂTWEAݒ肵܂B
				else
					TWCR = (1<<TWINT) | (1<<TWEA) | (1<<TWEN);	// ÂTWEAݒ肵܂B
			}
			else
				if(TWS_RNAK == Status)			// 𐳓ɂ܂ُ͈Ƃē܂B
				{
					if(TW_TxBufCnt == 1)		// ُł͂ȂB呕uPEC]݂܂BUsePEC׸މ
					{
						TW_TxBufCnt = 0;		// ɏՕ
						UsePEC = 0;
					}
					else
						if(TW_TxBufCnt == 0)	// ُł͂ȂB呕uPEC(Ƃ𓾂邱)]݂܂BUsePECݒ
							UsePEC = 1;
						else					// ُ̈픭B߂NAK𓾂܂B
						{	// : TWIPʕ͍ײ݂ŁÂɂُ̈νĂɒʒmł܂B!!
							;
						}
					TW_state = TW_IDLE;			// SĂ̏ꍇűق֖߂܂B
					TWCR = (1<<TWINT) | (1<<TWEA) | (1<<TWEN);
				}
				else
//					if(TWS_FINAL == Status)		// ُ: ACK𓾂܂ް܂B!
					{	// TWIPʕ"ڽw肳ĂȂ]u"̂߁Aُ}ł܂B
						TW_state = TW_IDLE;		//ԋ@\ؾ
						TWCR = (1<<TWINT) | (1<<TWEA) | (1<<TWEN);
					}
			break;

	} // switch(TW_state)̍Ō
}


/* *************************************************************************
 *
 *   SMBusISP߉ߕ
 *
 ************************************************************************* */

void SMB_BusTimeout(void)
{
	int i;

	for(i=7000; i!=0; i--);		// JԂ428,000

	SMB_RestoreBus();
}

void SMB_Reply(void)
{
	unsigned char temp;

	TWI_CmdFlags = 0;			// ɗU׸ނ
	TW_TxBufIndex = 0;			// 
	TW_TxBufCnt = 0;			// 

	// _ŗLȉ''𑗂ԂƂłB
	TW_TxBuf[0] = 1;			// SMBus''޲Đ
	TW_TxBuf[1] = Status;		// Ԓl
	TW_TxBufIndex = 0;			// ʒuJnɖ߂B
	TW_TxBufCnt = 2;			// ̊ɏՕ̗L޲Đ

	// ̗v܂*S*PʏpPEC
	temp = FastCRC(0, (TWAR & 0xFE));			// SLA+Wڽgp
	temp = FastCRC(temp, SMBV_Opt5);
	temp = FastCRC(temp, (TWAR | 1));			// SLA+Rڽgp

	do {temp = FastCRC(temp, TW_TxBuf[TW_TxBufIndex++]);}
		while(TW_TxBufIndex != TW_TxBufCnt);

	TW_TxBuf[TW_TxBufIndex] = temp;				// ŌCRClǉ
	TW_TxBufCnt++;								// PECp޲Čv
	TW_TxBufIndex = 0;							// ɏՕʒuwqؾ
	TWCR = (1<<TWINT) | (1<<TWEA) | (1<<TWEN);	// ꎞ~ʒuTWIp
}

unsigned char EEbusy(void)
{
	return (EECR & (1<<EEPE));
}

unsigned char EEget(unsigned int address)
{
	while(EECR & (1<<EEPE));
	EEAR = address;
	EECR |= (1<<EERE);
	return EEDR;
}

void EEerase(unsigned int address)
{
	while(EECR & (1<<EEPE));
	EEAR = address;
	EECR = (1<<EEPM0) | (1<<EEMPE);
	EECR = (1<<EEPM0) | (1<<EEMPE) | (1<<EEPE);
}

void EEwrite(unsigned int address, unsigned char data)
{
	while(EECR & (1<<EEPE));
	EEAR = address;
	EEDR = data;
	EECR = (1<<EEMPE);				// Ə݂s܂B
	EECR = (1<<EEMPE) | (1<<EEPE);
}

void LoopMemory(void)
{
	if(LoopFlag == 'E')		// "EEPROM"܂B
	{
		if(EEbusy())
			return;
		EEwrite(eptr++, SRAMbuffer[dest_i++]);
		if(--ctr)
			return;
		Status = SUCCESS;
		LoopFlag = 0;
		return;
	}
	else
	if(LoopFlag == 'e')		// "EEPROM"܂B
	{
		if(EEbusy())
			return;
		EEerase(eptr++);
		if(--ctr)
			return;
		Status = SUCCESS;
		LoopFlag = 0;
		return;
	}
}

// ̊֐͎󂯎߂߂܂B
void SMB_CmdInterpreter(void)
{
	unsigned char temp;

	if(UsePEC)											// 󂯎߹ĂCRC
	{
		temp = 0;										// 쐬CRClƂĎgp

		do { temp = FastCRC(temp, TW_RxBuf[TW_RxBufIndex++]); }
		while(TW_RxBufCnt != TW_RxBufIndex);

		if(temp)										// SĂOKȂACRČʂ=0ɂȂׂłB
		{
			Status = CRCERROR;
			TWCR = (1<<TWINT) | (1<<TWEA) | (1<<TWEN);	// ꎞ~ꏊTWIp
			return;
		}
	}
	// үނ͊e߂̏Ăяo̐ɏ[LłB
	Status = BUSY;								// ̏ꍇA"JԂ"

	if(!BigData)
	{
	//  TW_RxBufIndex = 3;						// Mް̐擪޲Ăւ̈ʒuwq
		lomemptr = TW_RxBuf[TWRX_LOADDR];
		himemptr = TW_RxBuf[TWRX_HIADDR];
		src_i = TWRX_DATA;
		dest_i = TW_RxBuf[TWRX_OFFSET];
		ctr = TW_RxBuf[TWRX_SIZE];

		temp = TW_RxBuf[TWRX_CMD];				// ߂͉?
	}
	else
	{
		temp = 'I';
		src_i = 3;								// S㑱ɑ΂āAް3Ŏn܂ȂȂ΂Ȃ܂!
		// ctrdest_i͒Ỏ򂩂疢LȂƂɒӂĂB
	}

	if(temp == 'W')						// SRAMbufferް؂ɏ
	{
		if(TW_RxBuf[TWRX_MEM] == 'F')	// ׯ ?
		{
			src_i = 0;							// SRAMbufferւ̎wW
			lomemptr &= 0x80;					// ߰ދEmȂƂۏ
			dest_i = lomemptr;
			do
			{
				#pragma diag_suppress=Pe1053	// long^ڽׯptrւ̕ϊɑ΂x}
				_FILL_TEMP_WORD(((himemptr<<8)|dest_i), (SRAMbuffer[src_i]|(SRAMbuffer[src_i+1]<<8)));
				#pragma diag_default=Pe1053		// ɕA
				src_i += 2;						// SRAMbuffer̎̌I
				dest_i += 2;					// ׯ ߰ވʒuwqXV
			}
			while(src_i < 0x80);				// S޲Ă܂ŌJԂ

			_PAGE_WRITE((himemptr<<8)|lomemptr);
			_WAIT_FOR_SPM();
			_ENABLE_RWW_SECTION();

			Status = SUCCESS;
		}
		else
		if(TW_RxBuf[TWRX_MEM] == 'E')	// EEPROM?
		{
			eptr = (himemptr<<8) | lomemptr;
			if((eptr + ctr) > 512)
				Status = BADPARAM;
			else
			{
				LoopFlag = 'E';					//"EEPROM"܂B
			}
		}
    	else
		Status = BADPARAM;
	}

	else
	if(temp == 'V')						// ؂ɑ΂SRAMbuffeȑ
	{
		if(TW_RxBuf[TWRX_MEM] == 'F')	// ׯ ?
		{
			src_i = SUCCESS;					// Ԃێ̂ɂ̕ϐgp
			dest_i = 0;
			fptr = (unsigned char __flash *)(lomemptr | (himemptr<<8));
			do { if(SRAMbuffer[dest_i++] != *fptr++) src_i=FAILURE; }
			while (dest_i < 128);
			Status = src_i;
		}
		else
		if(TW_RxBuf[TWRX_MEM] == 'E')	// EEPROM?
		{
			eptr = (himemptr<<8) | lomemptr;
			if((eptr + ctr) > 512)
				Status = BADPARAM;
			else
			{
				src_i = SUCCESS;				// Ԃێ̂ɂ̕ϐgp
				do { if(SRAMbuffer[dest_i++] != EEget(eptr++)) src_i=FAILURE; }
				while (--ctr);
				Status = src_i;
			}
		}
		else
			Status = BADPARAM;
	}

	else
	if(temp == 'E')						// wڽŎn܂؂
	{
		if(TW_RxBuf[TWRX_MEM] == 'F')	// ׯ ?
		{
			_WAIT_FOR_SPM();
			#pragma diag_suppress=Pe1053	// long^ڽׯptrւ̕ϊɑ΂x}
			_PAGE_ERASE( (himemptr<<8) | (lomemptr & 0x80) );
			#pragma diag_default=Pe1053		// ɕA

			Status = SUCCESS;
		}
		else
		if(TW_RxBuf[TWRX_MEM] == 'E')	// EEPROM?
		{
			eptr = (himemptr<<8) | lomemptr;
			if((eptr + ctr) > 512)
				Status = BADPARAM;
			else
			{
				LoopFlag = 'e';					// "EEPROM"܂B
			}
		}
		else
			Status = BADPARAM;
	}

	else
	if(temp == 'P')						// SRAMbufferɓǂނƂɂ؂̉pڂ
	{
		if(TW_RxBuf[TWRX_MEM] == 'F')	// ׯ ?
		{
			if(lomemptr & 0x7F)			// ߰ދEłȂ΂Ȃ܂!!
				Status = BADPARAM;
			else
			{
				dest_i = 0;
				fptr = (unsigned char __flash *)(lomemptr | (himemptr<<8));
				do {SRAMbuffer[dest_i++] = *fptr++; }
				while (dest_i < 128);
				Status = SUCCESS;
			}
		}
		else
		if(TW_RxBuf[TWRX_MEM] == 'E')	// EEPROM?
		{
			eptr = (himemptr<<8) | lomemptr;
			if((eptr + ctr) > 512)
				Status = BADPARAM;
			else
			{
				do { SRAMbuffer[dest_i++] = EEget(eptr++); }
				while (--ctr);
				Status = SUCCESS;
			}
		}
		else
			Status = BADPARAM;
	}

	else
	if(temp == 'A')				// ް۰ISPޗL(̺ނł͖)
	{
		Status = SUCCESS;						// vȂAPɖ
	}

	else
	if(temp == 'I')				// ߹Ăްw肳ꂽψʂSRAMbufferɑ}
	{
		if((ctr+dest_i) > 128)
			Status = BADPARAM;
		else
		{
			if(!BigData)
			{
				if(ctr > 26)	// ߹Ăɍvł̂26ő
				{
					BigData = 1;
					temp = TW_RxBuf[TWRX_BLKCNT] - 6;
				}
				else
					temp = ctr;
			}
			else				// ͘A߹Ă32޲Ă܂łް܂ނ܂B
			{
				if(ctr <= TW_RxBuf[TWRX_BLKCNT])
					BigData = 0;
				temp = TW_RxBuf[TWRX_BLKCNT];
			}

			do
			{
				SRAMbuffer[dest_i++] = TW_RxBuf[src_i++];
				ctr--;
			}
			while (--temp);
			Status = SUCCESS;
		}
	}

	else
	if(temp == 'w')				// SRAMŜ𕜍Ǎɏ
	{
		; //! \todo Í]܂ꍇͺނɒǉĂB
	}

	else
	if(temp == 'v')				// SRAMŜ𕜍ǍɌ
	{
		; //! \todo Í]܂ꍇͺނɒǉĂB
	}

	else
	if(temp == 'X')				// ް۰ޔo
	{
		asm("jmp 0");
	}

	else						// ꗗŗL߂Ȃ
	{
		SMB_BusTimeout();						// ޽Ԑ
		TW_RxBufIndex = 0;						// Ô߁AɏՕ|
		TW_RxBufCnt = 0;
		return;
	}
	// ̎_őSOK̂悤łB
	TWCR = (1<<TWINT) | (1<<TWEA) | (1<<TWEN);	// ꎞ~̏ꏊTWIp
	return;
}

// ̊֐(Ō̖߂ŉsƂ呕uɍ邽߂)޽
// Ԉُ킪̈ӂɐꂽSMBusTWI_ISRʏɉ񕜂܂B
void SMB_RestoreBus(void)
{
	TWCR = 0;				// Ӌ@\~
	TW_state = TW_IDLE;		// ԋ@\̏
	TWAR = 0x16;
	TWCR = (1<<TWINT) | (1<<TWEA) | (1<<TWEN);	// | (1<<TWSTO)  // ċ

	// ŒӂȂ΂ȂȂ̂́AǍʂƂĈ޽ُ𐶐
	// Ȃ悤ɂ邱ƂŁAȂ΁AIDLEԂAɌ鉽
	// Ȃꍇɕʂ޽Ԃ𐶐ĖJԂɊׂ܂B
}


/* *************************************************************************
 *
 *   SUBusʐMpհèè
 *
 ************************************************************************* */

__flash unsigned char crctable[16] =  {0,0x07,0x0E,0x90, 0x1c,0x1b,0x12,0x15, 0x38,0x3F,0x36,0x31, 0x24,0x23,0x2A,0x2D};
__flash unsigned char crctable2[16] = {0,0x70,0xE0,0x90, 0xC1,0xB1,0x21,0x51, 0x83,0xF3,0x63,0x13, 0x42,0x32,0xA2,0xD2};

unsigned char FastCRC(unsigned char LastCRC, unsigned char newbyte)
{
	unsigned char index;

	index = newbyte;
	index ^= LastCRC;
	index >>= 4;
	LastCRC &= 0x0F;
	LastCRC ^= crctable2[index];

	index = LastCRC;
	index ^= newbyte;
	index &= 0x0F;
	LastCRC &= 0xF0;
	LastCRC ^= crctable[index];

	return(LastCRC);
}

/* {łcrctable2[]KvƂ܂񂪁A葽ޯĈړKvƂ܂B
unsigned char SlowerCRC(unsigned char LastCRC, unsigned char newbyte)
{
	unsigned char index;

	index = newbyte;
	index ^= LastCRC;
	index >>= 4;
	LastCRC <<= 4;
	LastCRC ^= crctable[index];

	index = LastCRC >> 4;
	index ^= newbyte;
	index &= 0x0F;
	LastCRC <<= 4;
	LastCRC ^= crctable[index];

	return(LastCRC);
} */
